---
title: 'BroadcastChannel: message event'
slug: Web/API/BroadcastChannel/message_event
tags:
  - Communication
  - Event
  - EventSource
  - Reference
  - message
  - messaging
---
<div>{{APIRef}}</div>

<p>The <code>message</code> event is fired on a {{domxref('BroadcastChannel')}} object when a message arrives on that channel.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("MessageEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td><code><a href="/en-US/docs/Web/API/BroadcastChannel/onmessage">onmessage</a></code></td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<h3 id="Live_example">Live example</h3>

<p>In this example there's a "sender" <code><a href="/en-US/docs/Web/HTML/Element/iframe">&lt;iframe&gt;</a></code> that broadcasts the contents of a <code><a href="/en-US/docs/Web/HTML/Element/textarea">&lt;textarea&gt;</a></code> when the user clicks a button. There are two "receiver" iframes that listen to the broadcast message and write the result into a <code><a href="/en-US/docs/Web/HTML/Element/div">&lt;div&gt;</a></code> element.</p>

<h4 id="Sender">Sender</h4>

<div class="hidden">
<pre class="brush: html notranslate">&lt;h1&gt;Sender&lt;/h1&gt;
&lt;label for="message"&gt;Type a message to broadcast:&lt;/label&gt;&lt;br/&gt;
&lt;textarea id="message" name="message" rows="1" cols="40"&gt;Hello&lt;/textarea&gt;
&lt;button id="broadcast-message" type="button"&gt;Broadcast message&lt;/button&gt;</pre>

<pre class="brush: css notranslate">body {
     border: 1px solid black;
     padding: .5rem;
     height: 150px;
     font-family: "Fira Sans", sans-serif;
}

h1 {
    font: 1.6em "Fira Sans", sans-serif;
    margin-bottom: 1rem;
}

textarea {
    padding: .2rem;
}

label, br {
    margin: .5rem 0;
}

button {
    vertical-align: top;
    height: 1.5rem;
}</pre>
</div>

<pre class="brush: js notranslate">const channel = new BroadcastChannel('example-channel');
const messageControl = document.querySelector('#message');
const broadcastMessageButton = document.querySelector('#broadcast-message');

broadcastMessageButton.addEventListener('click', () =&gt; {
    channel.postMessage(messageControl.value);
})
</pre>

<h4 id="Receiver_1">Receiver 1</h4>

<div class="hidden">
<pre class="brush: html notranslate">&lt;h1&gt;Receiver 1&lt;/h1&gt;
&lt;div id="received"&gt;&lt;/div&gt;</pre>

<pre class="brush: css notranslate">body {
    border: 1px solid black;
    padding: .5rem;
    height: 100px;
    font-family: "Fira Sans", sans-serif;
}

h1 {
    font: 1.6em "Fira Sans",
    sans-serif; margin-bottom: 1rem;
}
</pre>
</div>

<pre class="brush: js notranslate">const channel = new BroadcastChannel('example-channel');
channel.addEventListener('message', (event) =&gt; {
  received.textContent = event.data;
});</pre>

<h4 id="Receiver_2">Receiver 2</h4>

<div class="hidden">
<pre class="brush: html notranslate">&lt;h1&gt;Receiver 2&lt;/h1&gt;
&lt;div id="received"&gt;&lt;/div&gt;</pre>

<pre class="brush: css notranslate">body {
    border: 1px solid black;
    padding: .5rem;
    height: 100px;
    font-family: "Fira Sans", sans-serif;
}

h1 {
    font: 1.6em "Fira Sans", sans-serif;
    margin-bottom: 1rem;
}
</pre>
</div>

<pre class="brush: js notranslate">const channel = new BroadcastChannel('example-channel');
channel.addEventListener('message', (event) =&gt; {
  received.textContent = event.data;
});</pre>

<h3 id="Result">Result</h3>

<p>{{ EmbedLiveSample('Sender', '100%', '170px','' ,'' , 'dummy') }}</p>

<p>{{ EmbedLiveSample('Receiver_1', '100%', '150px','' ,'' , 'dummy') }}</p>

<p>{{ EmbedLiveSample('Receiver_2', '100%', '150px','' ,'' , 'dummy') }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'indices.html#event-message')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.BroadcastChannel.message_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Related events: <code><a href="/docs/Web/API/BroadcastChannel/messageerror_event">messageerror</a></code>.</li>
</ul>
